
.. DO NOT EDIT.
.. THIS FILE WAS AUTOMATICALLY GENERATED BY SPHINX-GALLERY.
.. TO MAKE CHANGES, EDIT THE SOURCE PYTHON FILE:
.. "auto_examples/plot_onnxscript_102.py"
.. LINE NUMBERS ARE GIVEN BELOW.

.. only:: html

    .. note::
        :class: sphx-glr-download-link-note

        :ref:`Go to the end <sphx_glr_download_auto_examples_plot_onnxscript_102.py>`
        to download the full example code.

.. rst-class:: sphx-glr-example-title

.. _sphx_glr_auto_examples_plot_onnxscript_102.py:


.. _l-plot-onnxscript-102:

=============================
102: Examples with onnxscript
=============================

This script gathers a couple of examples based on :epkg:`onnxscript`.

Custom Opset and Local Functions
================================

.. GENERATED FROM PYTHON SOURCE LINES 13-40

.. code-block:: Python


    import onnx
    import onnxscript

    op = onnxscript.opset18
    my_opset = onnxscript.values.Opset("m_opset.ml", version=1)


    @onnxscript.script(my_opset, default_opset=op)
    def do_this(x, y):
        return op.Add(x, y)


    @onnxscript.script(my_opset, default_opset=op)
    def do_that(x, y):
        return op.Sub(x, y)


    @onnxscript.script(my_opset, default_opset=op)
    def do_this_or_do_that(x, y, do_this_or_do_that: bool = True):
        if do_this_or_do_that:
            ret = my_opset.do_this(x, y)
        else:
            ret = my_opset.do_that(x, y)
        return ret






.. rst-class:: sphx-glr-script-out

 .. code-block:: none

    /home/xadupre/github/onnxscript/onnxscript/converter.py:820: FutureWarning: 'onnxscript.values.Op.param_schemas' is deprecated in version 0.1 and will be removed in the future. Please use '.op_signature' instead.
      param_schemas = callee.param_schemas()
    'do_this' is not a known op in 'm_opset.ml'
    'do_that' is not a known op in 'm_opset.ml'




.. GENERATED FROM PYTHON SOURCE LINES 41-42

Then we export the model into ONNX.

.. GENERATED FROM PYTHON SOURCE LINES 42-45

.. code-block:: Python


    proto = do_this_or_do_that.to_model_proto(functions=[do_this, do_that])
    print(onnx.printer.to_text(proto))




.. rst-class:: sphx-glr-script-out

 .. code-block:: none

    <
       ir_version: 8,
       opset_import: ["" : 18, "m_opset.ml" : 1]
    >
    do_this_or_do_that ( x,  y) => ( ret_1) {
       [n0] do_this_or_do_that = Constant <value_int: int = @do_this_or_do_that> ()
       [n1] do_this_or_do_that_as_bool = Cast <to: int = 9> (do_this_or_do_that)
       [n2] ret_1 = If (do_this_or_do_that_as_bool) <then_branch: graph = thenGraph_3 () => ( ret) {
          [n0] ret = m_opset.ml.do_this (x, y)
       }, else_branch: graph = elseGraph_3 () => ( ret_0) {
          [n0] ret_0 = m_opset.ml.do_that (x, y)
       }>
    }
    <
      domain: "m_opset.ml",
      opset_import: ["" : 18]
    >
    do_this (x, y) => (return_val)
    {
       [n0] return_val = Add (x, y)
    }
    <
      domain: "m_opset.ml",
      opset_import: ["" : 18]
    >
    do_that (x, y) => (return_val)
    {
       [n0] return_val = Sub (x, y)
    }





.. rst-class:: sphx-glr-timing

   **Total running time of the script:** (0 minutes 0.247 seconds)


.. _sphx_glr_download_auto_examples_plot_onnxscript_102.py:

.. only:: html

  .. container:: sphx-glr-footer sphx-glr-footer-example

    .. container:: sphx-glr-download sphx-glr-download-jupyter

      :download:`Download Jupyter notebook: plot_onnxscript_102.ipynb <plot_onnxscript_102.ipynb>`

    .. container:: sphx-glr-download sphx-glr-download-python

      :download:`Download Python source code: plot_onnxscript_102.py <plot_onnxscript_102.py>`

    .. container:: sphx-glr-download sphx-glr-download-zip

      :download:`Download zipped: plot_onnxscript_102.zip <plot_onnxscript_102.zip>`


.. only:: html

 .. rst-class:: sphx-glr-signature

    `Gallery generated by Sphinx-Gallery <https://sphinx-gallery.github.io>`_
